/* Generated by re2c 1.0.3 */
#line 1 "mwlib/_uscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2009 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_singlequote,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
	t_uniq,

	t_ebad,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
		last_ebad = false;
	}

	int found(mwtok val) {
		if (val==t_ebad) {
			last_ebad=true;
			return tokens.size()-1;
		}

		if (val==t_text && tokens.size() && !last_ebad) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		
		last_ebad = false;

		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	bool last_ebad;
	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 145 "mwlib/_uscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 184 "mwlib/_uscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 161 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= ',') {
		if (yych <= '!') {
			if (yych <= '\t') {
				if (yych >= '\t') goto yy4;
			} else {
				if (yych <= 0x001F) goto yy2;
				if (yych <= ' ') goto yy5;
				goto yy7;
			}
		} else {
			if (yych <= '#') {
				if (yych >= '#') goto yy9;
			} else {
				if (yych == '*') goto yy9;
			}
		}
	} else {
		if (yych <= '<') {
			if (yych <= '9') {
				if (yych <= '-') goto yy12;
			} else {
				if (yych <= ':') goto yy13;
				if (yych <= ';') goto yy9;
			}
		} else {
			if (yych <= 'z') {
				if (yych <= '=') goto yy15;
			} else {
				if (yych <= '{') goto yy18;
				if (yych <= '|') goto yy19;
			}
		}
	}
yy2:
	++YYCURSOR;
yy3:
#line 236 "mwlib/_uscan.re"
	{goto not_bol;}
#line 204 "mwlib/_uscan.cc"
yy4:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '!') {
		if (yych == '\t') goto yy21;
		if (yych <= 0x001F) goto yy3;
		goto yy21;
	} else {
		if (yych <= ':') {
			if (yych <= '9') goto yy3;
			goto yy21;
		} else {
			if (yych <= 'z') goto yy3;
			if (yych <= '|') goto yy21;
			goto yy3;
		}
	}
yy5:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '!') {
		if (yych == '\t') goto yy21;
		if (yych >= ' ') goto yy21;
	} else {
		if (yych <= ':') {
			if (yych >= ':') goto yy21;
		} else {
			if (yych <= 'z') goto yy6;
			if (yych <= '|') goto yy21;
		}
	}
yy6:
#line 228 "mwlib/_uscan.re"
	{RET(t_pre);}
#line 239 "mwlib/_uscan.cc"
yy7:
	++YYCURSOR;
yy8:
#line 204 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 256 "mwlib/_uscan.cc"
yy9:
	yych = *++YYCURSOR;
	if (yych <= ')') {
		if (yych == '#') goto yy9;
	} else {
		if (yych <= '*') goto yy9;
		if (yych <= '9') goto yy11;
		if (yych <= ';') goto yy9;
	}
yy11:
#line 233 "mwlib/_uscan.re"
	{RET(t_item);}
#line 269 "mwlib/_uscan.cc"
yy12:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '-') goto yy26;
	goto yy3;
yy13:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych <= '#') {
			if (yych <= '"') goto yy11;
			goto yy9;
		} else {
			if (yych == '*') goto yy9;
			goto yy11;
		}
	} else {
		if (yych <= ';') {
			if (yych <= ':') goto yy13;
			goto yy9;
		} else {
			if (yych == '{') goto yy25;
			goto yy11;
		}
	}
yy15:
	yych = *++YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy27;
	} else {
		if (yych <= ' ') goto yy27;
		if (yych == '=') goto yy15;
	}
yy17:
#line 229 "mwlib/_uscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 309 "mwlib/_uscan.cc"
yy18:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy29;
	goto yy3;
yy19:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy31;
		goto yy8;
	} else {
		if (yych <= '-') goto yy34;
		if (yych == '}') goto yy37;
		goto yy8;
	}
yy20:
	yych = *++YYCURSOR;
yy21:
	if (yych <= '!') {
		if (yych <= '\t') {
			if (yych >= '\t') goto yy20;
		} else {
			if (yych <= 0x001F) goto yy22;
			if (yych <= ' ') goto yy20;
			goto yy7;
		}
	} else {
		if (yych <= 'z') {
			if (yych == ':') goto yy23;
		} else {
			if (yych <= '{') goto yy25;
			if (yych <= '|') goto yy19;
		}
	}
yy22:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept == 0) {
			goto yy3;
		} else {
			goto yy6;
		}
	} else {
		goto yy11;
	}
yy23:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy23;
	if (yych != '{') goto yy22;
yy25:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy29;
	goto yy22;
yy26:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy39;
	goto yy22;
yy27:
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy27;
	if (yych == ' ') goto yy27;
	goto yy17;
yy29:
	++YYCURSOR;
#line 189 "mwlib/_uscan.re"
	{++tablemode; RET(t_begin_table);}
#line 375 "mwlib/_uscan.cc"
yy31:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy31;
#line 218 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 389 "mwlib/_uscan.cc"
yy34:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy34;
#line 193 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 403 "mwlib/_uscan.cc"
yy37:
	++YYCURSOR;
#line 190 "mwlib/_uscan.re"
	{if (--tablemode<0) tablemode=0; RET(t_end_table);}
#line 408 "mwlib/_uscan.cc"
yy39:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy22;
yy40:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy40;
#line 234 "mwlib/_uscan.re"
	{RET(t_hrule);}
#line 417 "mwlib/_uscan.cc"
}
#line 237 "mwlib/_uscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 428 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= ' ') {
				if (yych <= 0x0000) goto yy45;
				if (yych == '\n') goto yy49;
				goto yy47;
			} else {
				if (yych <= '%') {
					if (yych <= '!') goto yy51;
					goto yy47;
				} else {
					if (yych <= '&') goto yy52;
					if (yych <= '\'') goto yy53;
					goto yy47;
				}
			}
		} else {
			if (yych <= '=') {
				if (yych <= ':') {
					if (yych <= '9') goto yy54;
					goto yy57;
				} else {
					if (yych <= ';') goto yy47;
					if (yych <= '<') goto yy59;
					goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy47;
					goto yy54;
				} else {
					if (yych <= '[') goto yy63;
					if (yych <= '\\') goto yy47;
					goto yy64;
				}
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'e') {
				if (yych == '_') goto yy65;
				if (yych <= '`') goto yy47;
				goto yy54;
			} else {
				if (yych <= 'g') {
					if (yych <= 'f') goto yy67;
					goto yy54;
				} else {
					if (yych <= 'h') goto yy68;
					if (yych <= 'i') goto yy69;
					goto yy54;
				}
			}
		} else {
			if (yych <= '|') {
				if (yych <= 'n') {
					if (yych <= 'm') goto yy70;
					goto yy71;
				} else {
					if (yych <= 'z') goto yy54;
					if (yych <= '{') goto yy47;
					goto yy72;
				}
			} else {
				if (yych <= 0x007F) {
					if (yych <= '~') goto yy47;
					goto yy73;
				} else {
					if (yych == 0xEBAD) goto yy74;
					goto yy47;
				}
			}
		}
	}
yy45:
	++YYCURSOR;
#line 312 "mwlib/_uscan.re"
	{newline(); return t_end;}
#line 511 "mwlib/_uscan.cc"
yy47:
	++YYCURSOR;
yy48:
#line 313 "mwlib/_uscan.re"
	{RET(t_text);}
#line 517 "mwlib/_uscan.cc"
yy49:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '\n') goto yy76;
	if (yych == ' ') goto yy79;
yy50:
#line 285 "mwlib/_uscan.re"
	{newline(); RET(t_newline);}
#line 526 "mwlib/_uscan.cc"
yy51:
	yych = *++YYCURSOR;
	if (yych == '!') goto yy82;
	goto yy48;
yy52:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych == '#') goto yy84;
		if (yych <= '/') goto yy48;
		goto yy85;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy48;
			goto yy85;
		} else {
			if (yych <= '`') goto yy48;
			if (yych <= 'z') goto yy85;
			goto yy48;
		}
	}
yy53:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy87;
	goto yy48;
yy54:
	yych = *++YYCURSOR;
yy55:
	if (yych <= '@') {
		if (yych <= '/') goto yy56;
		if (yych <= '9') goto yy54;
	} else {
		if (yych <= 'Z') goto yy54;
		if (yych <= '`') goto yy56;
		if (yych <= 'z') goto yy54;
	}
yy56:
#line 259 "mwlib/_uscan.re"
	{RET(t_text);}
#line 566 "mwlib/_uscan.cc"
yy57:
	++YYCURSOR;
yy58:
#line 303 "mwlib/_uscan.re"
	{RET(t_special);}
#line 572 "mwlib/_uscan.cc"
yy59:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych == '!') goto yy90;
		if (yych <= '.') goto yy48;
		goto yy91;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy48;
			goto yy92;
		} else {
			if (yych <= '`') goto yy48;
			if (yych <= 'z') goto yy92;
			goto yy48;
		}
	}
yy60:
	yych = *++YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy94;
	} else {
		if (yych <= ' ') goto yy94;
		if (yych == '=') goto yy60;
	}
yy62:
#line 263 "mwlib/_uscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 612 "mwlib/_uscan.cc"
yy63:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '[':	goto yy96;
	case 'f':	goto yy98;
	case 'h':	goto yy99;
	case 'i':	goto yy100;
	case 'm':	goto yy101;
	case 'n':	goto yy102;
	default:	goto yy58;
	}
yy64:
	yych = *++YYCURSOR;
	if (yych == ']') goto yy103;
	goto yy58;
yy65:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy105;
yy66:
#line 260 "mwlib/_uscan.re"
	{RET(t_text);}
#line 635 "mwlib/_uscan.cc"
yy67:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy106;
	goto yy55;
yy68:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy107;
	goto yy55;
yy69:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy108;
	goto yy55;
yy70:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy109;
	goto yy55;
yy71:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy110;
	goto yy55;
yy72:
	yych = *++YYCURSOR;
	if (yych <= '*') {
		if (yych == '!') goto yy82;
		goto yy58;
	} else {
		if (yych <= '+') goto yy111;
		if (yych == '|') goto yy82;
		goto yy58;
	}
yy73:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'U') goto yy113;
	goto yy48;
yy74:
	++YYCURSOR;
#line 245 "mwlib/_uscan.re"
	{RET(t_ebad);}
#line 675 "mwlib/_uscan.cc"
yy76:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '\n') goto yy76;
	if (yych == ' ') goto yy79;
yy78:
#line 276 "mwlib/_uscan.re"
	{newline();
		 Py_UNICODE *tmp = cursor;

		 cursor = start+1;
		 found(t_newline);
		 start += 1;
		 cursor = tmp;  
		 RET(t_break);
		}
#line 692 "mwlib/_uscan.cc"
yy79:
	yych = *++YYCURSOR;
	if (yych == '\n') goto yy76;
	if (yych == ' ') goto yy79;
yy81:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy50;
			} else {
				goto yy48;
			}
		} else {
			goto yy58;
		}
	} else {
		if (yyaccept <= 4) {
			if (yyaccept == 3) {
				goto yy78;
			} else {
				goto yy66;
			}
		} else {
			goto yy56;
		}
	}
yy82:
	++YYCURSOR;
#line 287 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 732 "mwlib/_uscan.cc"
yy84:
	yych = *++YYCURSOR;
	if (yych <= 'W') {
		if (yych <= '/') goto yy81;
		if (yych <= '9') goto yy114;
		goto yy81;
	} else {
		if (yych <= 'X') goto yy116;
		if (yych == 'x') goto yy116;
		goto yy81;
	}
yy85:
	yych = *++YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy81;
		if (yych <= '9') goto yy85;
		if (yych <= ':') goto yy81;
		goto yy117;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy81;
			goto yy85;
		} else {
			if (yych <= '`') goto yy81;
			if (yych <= 'z') goto yy85;
			goto yy81;
		}
	}
yy87:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy87;
#line 304 "mwlib/_uscan.re"
	{RET(t_singlequote);}
#line 766 "mwlib/_uscan.cc"
yy90:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy119;
	goto yy81;
yy91:
	yych = *++YYCURSOR;
	if (yych <= '@') goto yy81;
	if (yych <= 'Z') goto yy92;
	if (yych <= '`') goto yy81;
	if (yych >= '{') goto yy81;
yy92:
	yych = *++YYCURSOR;
	if (yych <= '<') {
		if (yych <= 0x0000) goto yy81;
		if (yych <= ';') goto yy92;
		goto yy81;
	} else {
		if (yych == '>') goto yy120;
		goto yy92;
	}
yy94:
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy94;
	if (yych == ' ') goto yy94;
	goto yy62;
yy96:
	++YYCURSOR;
#line 261 "mwlib/_uscan.re"
	{RET(t_2box_open);}
#line 796 "mwlib/_uscan.cc"
yy98:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy122;
	goto yy81;
yy99:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy123;
	goto yy81;
yy100:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy124;
	goto yy81;
yy101:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy125;
	goto yy81;
yy102:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy126;
	goto yy81;
yy103:
	++YYCURSOR;
#line 262 "mwlib/_uscan.re"
	{RET(t_2box_close);}
#line 821 "mwlib/_uscan.cc"
yy105:
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'E':	goto yy127;
	case 'F':	goto yy128;
	case 'N':	goto yy129;
	case 'S':	goto yy130;
	case 'T':	goto yy131;
	default:	goto yy133;
	}
yy106:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy134;
	goto yy55;
yy107:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy135;
	goto yy55;
yy108:
	yych = *++YYCURSOR;
	if (yych == 'c') goto yy136;
	goto yy55;
yy109:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy137;
	goto yy55;
yy110:
	yych = *++YYCURSOR;
	if (yych == 'w') goto yy138;
	goto yy55;
yy111:
	++YYCURSOR;
#line 297 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 862 "mwlib/_uscan.cc"
yy113:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy139;
	goto yy81;
yy114:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy81;
	if (yych <= '9') goto yy114;
	if (yych == ';') goto yy117;
	goto yy81;
yy116:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy81;
	goto yy141;
yy117:
	++YYCURSOR;
#line 310 "mwlib/_uscan.re"
	{RET(t_entity);}
#line 881 "mwlib/_uscan.cc"
yy119:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy142;
	goto yy81;
yy120:
	++YYCURSOR;
#line 306 "mwlib/_uscan.re"
	{RET(t_html_tag);}
#line 890 "mwlib/_uscan.cc"
yy122:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy144;
	goto yy81;
yy123:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy145;
	goto yy81;
yy124:
	yych = *++YYCURSOR;
	if (yych == 'c') goto yy146;
	goto yy81;
yy125:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy147;
	goto yy81;
yy126:
	yych = *++YYCURSOR;
	if (yych == 'w') goto yy148;
	goto yy81;
yy127:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy149;
	goto yy81;
yy128:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy150;
	goto yy81;
yy129:
	yych = *++YYCURSOR;
	if (yych <= 'N') {
		if (yych == 'E') goto yy151;
		goto yy81;
	} else {
		if (yych <= 'O') goto yy152;
		if (yych == 'U') goto yy153;
		goto yy81;
	}
yy130:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy154;
	goto yy81;
yy131:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy155;
	goto yy81;
yy132:
	yych = *++YYCURSOR;
yy133:
	if (yych == '_') goto yy132;
	goto yy66;
yy134:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy156;
	goto yy55;
yy135:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy157;
	goto yy55;
yy136:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy158;
	goto yy55;
yy137:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy159;
	goto yy55;
yy138:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy160;
	goto yy55;
yy139:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy161;
	goto yy81;
yy140:
	yych = *++YYCURSOR;
yy141:
	if (yych <= ';') {
		if (yych <= '/') goto yy81;
		if (yych <= '9') goto yy140;
		if (yych <= ':') goto yy81;
		goto yy117;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy81;
			goto yy140;
		} else {
			if (yych <= '`') goto yy81;
			if (yych <= 'f') goto yy140;
			goto yy81;
		}
	}
yy142:
	yych = *++YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy81;
		if (yych == '-') goto yy162;
		goto yy142;
	} else {
		if (yych == '=') goto yy142;
		if (yych <= '>') goto yy81;
		goto yy142;
	}
yy144:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy163;
	goto yy81;
yy145:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy164;
	goto yy81;
yy146:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy165;
	goto yy81;
yy147:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy166;
	goto yy81;
yy148:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy167;
	goto yy81;
yy149:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy168;
	goto yy81;
yy150:
	yych = *++YYCURSOR;
	if (yych == 'R') goto yy169;
	goto yy81;
yy151:
	yych = *++YYCURSOR;
	if (yych == 'W') goto yy170;
	goto yy81;
yy152:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':	goto yy171;
	case 'E':	goto yy172;
	case 'G':	goto yy173;
	case 'I':	goto yy174;
	case 'N':	goto yy175;
	case 'T':	goto yy176;
	default:	goto yy81;
	}
yy153:
	yych = *++YYCURSOR;
	if (yych == 'M') goto yy177;
	goto yy81;
yy154:
	yych = *++YYCURSOR;
	if (yych == 'A') goto yy178;
	goto yy81;
yy155:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy168;
	goto yy81;
yy156:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy179;
	goto yy81;
yy157:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy180;
	if (yych == 's') goto yy181;
	goto yy55;
yy158:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy182;
	goto yy81;
yy159:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy183;
	goto yy55;
yy160:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy184;
	goto yy55;
yy161:
	yych = *++YYCURSOR;
	if (yych == 'Q') goto yy185;
	goto yy81;
yy162:
	yych = *++YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy81;
		if (yych == '-') goto yy186;
		goto yy142;
	} else {
		if (yych == '=') goto yy142;
		if (yych <= '>') goto yy81;
		goto yy142;
	}
yy163:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy188;
	goto yy81;
yy164:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy189;
	if (yych == 's') goto yy190;
	goto yy81;
yy165:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy191;
	goto yy81;
yy166:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy192;
	goto yy81;
yy167:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy193;
	goto yy81;
yy168:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy194;
	goto yy81;
yy169:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy195;
	goto yy81;
yy170:
	yych = *++YYCURSOR;
	if (yych == 'S') goto yy196;
	goto yy81;
yy171:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy168;
	if (yych == 'O') goto yy197;
	goto yy81;
yy172:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy198;
	goto yy81;
yy173:
	yych = *++YYCURSOR;
	if (yych == 'A') goto yy199;
	goto yy81;
yy174:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy200;
	goto yy81;
yy175:
	yych = *++YYCURSOR;
	if (yych == 'U') goto yy153;
	goto yy81;
yy176:
	yych = *++YYCURSOR;
	if (yych <= 'H') {
		if (yych == 'C') goto yy168;
		goto yy81;
	} else {
		if (yych <= 'I') goto yy201;
		if (yych == 'O') goto yy202;
		goto yy81;
	}
yy177:
	yych = *++YYCURSOR;
	if (yych == 'B') goto yy203;
	goto yy81;
yy178:
	yych = *++YYCURSOR;
	if (yych == 'R') goto yy204;
	goto yy81;
yy179:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy205;
	goto yy81;
yy180:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy206;
	goto yy81;
yy181:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy180;
	goto yy55;
yy182:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy207;
	goto yy81;
yy183:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy208;
	goto yy55;
yy184:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych == '.') goto yy209;
		goto yy81;
	} else {
		if (yych <= '9') goto yy209;
		if (yych <= '@') goto yy81;
		if (yych <= 'a') goto yy209;
		goto yy81;
	}
yy185:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy212;
	goto yy81;
yy186:
	yych = *++YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy81;
		if (yych == '-') goto yy186;
		goto yy142;
	} else {
		if (yych <= '<') goto yy81;
		if (yych == '>') goto yy213;
		goto yy142;
	}
yy188:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy215;
	goto yy81;
yy189:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy216;
	goto yy81;
yy190:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy189;
	goto yy81;
yy191:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy217;
	goto yy81;
yy192:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy218;
	goto yy81;
yy193:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych == '.') goto yy219;
		goto yy81;
	} else {
		if (yych <= '9') goto yy219;
		if (yych <= '@') goto yy81;
		if (yych <= 'a') goto yy219;
		goto yy81;
	}
yy194:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy222;
	goto yy81;
yy195:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy224;
	goto yy81;
yy196:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy225;
	goto yy81;
yy197:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy226;
	goto yy81;
yy198:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy227;
	goto yy81;
yy199:
	yych = *++YYCURSOR;
	if (yych == 'L') goto yy228;
	goto yy81;
yy200:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy229;
	goto yy81;
yy201:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy230;
	goto yy81;
yy202:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy231;
	goto yy81;
yy203:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy232;
	goto yy81;
yy204:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy168;
	goto yy81;
yy205:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy81;
			if (yych <= '$') goto yy233;
			goto yy81;
		} else {
			if (yych <= ':') goto yy233;
			if (yych == '=') goto yy233;
			goto yy81;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy233;
			if (yych == '_') goto yy233;
			goto yy81;
		} else {
			if (yych == '|') goto yy81;
			if (yych <= '~') goto yy233;
			goto yy81;
		}
	}
yy206:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy236;
	goto yy81;
yy207:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '-') goto yy81;
		if (yych <= '9') goto yy237;
		goto yy81;
	} else {
		if (yych <= 'Z') goto yy237;
		if (yych <= '`') goto yy81;
		if (yych <= 'z') goto yy237;
		goto yy81;
	}
yy208:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy240;
	goto yy55;
yy209:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych == '.') goto yy209;
	} else {
		if (yych <= '9') goto yy209;
		if (yych <= '@') goto yy211;
		if (yych <= 'a') goto yy209;
	}
yy211:
#line 251 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1340 "mwlib/_uscan.cc"
yy212:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy81;
	goto yy242;
yy213:
	++YYCURSOR;
#line 309 "mwlib/_uscan.re"
	{RET(t_comment);}
#line 1349 "mwlib/_uscan.cc"
yy215:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy81;
			if (yych <= '$') goto yy243;
			goto yy81;
		} else {
			if (yych <= ':') goto yy243;
			if (yych == '=') goto yy243;
			goto yy81;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy243;
			if (yych == '_') goto yy243;
			goto yy81;
		} else {
			if (yych == '|') goto yy81;
			if (yych <= '~') goto yy243;
			goto yy81;
		}
	}
yy216:
	yych = *++YYCURSOR;
	if (yych == '/') goto yy246;
	goto yy81;
yy217:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '-') goto yy81;
		if (yych <= '9') goto yy247;
		goto yy81;
	} else {
		if (yych <= 'Z') goto yy247;
		if (yych <= '`') goto yy81;
		if (yych <= 'z') goto yy247;
		goto yy81;
	}
yy218:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy250;
	goto yy81;
yy219:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych == '.') goto yy219;
	} else {
		if (yych <= '9') goto yy219;
		if (yych <= '@') goto yy221;
		if (yych <= 'a') goto yy219;
	}
yy221:
#line 250 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1405 "mwlib/_uscan.cc"
yy222:
	++YYCURSOR;
#line 256 "mwlib/_uscan.re"
	{RET(t_magicword);}
#line 1410 "mwlib/_uscan.cc"
yy224:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy131;
	goto yy81;
yy225:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy251;
	goto yy81;
yy226:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy252;
	goto yy81;
yy227:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy253;
	goto yy81;
yy228:
	yych = *++YYCURSOR;
	if (yych == 'L') goto yy254;
	goto yy81;
yy229:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy255;
	goto yy81;
yy230:
	yych = *++YYCURSOR;
	if (yych == 'L') goto yy256;
	goto yy81;
yy231:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy257;
	if (yych == '_') goto yy194;
	goto yy81;
yy232:
	yych = *++YYCURSOR;
	if (yych == 'R') goto yy258;
	goto yy81;
yy233:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy235;
			if (yych <= '$') goto yy233;
		} else {
			if (yych <= ':') goto yy233;
			if (yych == '=') goto yy233;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy233;
			if (yych == '_') goto yy233;
		} else {
			if (yych == '|') goto yy235;
			if (yych <= '~') goto yy233;
		}
	}
yy235:
#line 253 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1470 "mwlib/_uscan.cc"
yy236:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '"') {
			if (yych == '!') goto yy259;
			goto yy81;
		} else {
			if (yych == '<') goto yy81;
			if (yych <= '=') goto yy259;
			goto yy81;
		}
	} else {
		if (yych <= '\\') {
			if (yych == '[') goto yy81;
			goto yy259;
		} else {
			if (yych <= ']') goto yy81;
			if (yych == 0x007F) goto yy81;
			goto yy259;
		}
	}
yy237:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '-') goto yy239;
		if (yych <= '9') goto yy237;
	} else {
		if (yych <= 'Z') goto yy237;
		if (yych <= '`') goto yy239;
		if (yych <= 'z') goto yy237;
	}
yy239:
#line 249 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1505 "mwlib/_uscan.cc"
yy240:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy81;
	goto yy263;
yy241:
	yych = *++YYCURSOR;
yy242:
	if (yych <= '/') {
		if (yych == '-') goto yy264;
		goto yy81;
	} else {
		if (yych <= '9') goto yy241;
		if (yych <= '`') goto yy81;
		if (yych <= 'z') goto yy241;
		goto yy81;
	}
yy243:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy245;
			if (yych <= '$') goto yy243;
		} else {
			if (yych <= ':') goto yy243;
			if (yych == '=') goto yy243;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy243;
			if (yych == '_') goto yy243;
		} else {
			if (yych == '|') goto yy245;
			if (yych <= '~') goto yy243;
		}
	}
yy245:
#line 252 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1544 "mwlib/_uscan.cc"
yy246:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '"') {
			if (yych == '!') goto yy265;
			goto yy81;
		} else {
			if (yych == '<') goto yy81;
			if (yych <= '=') goto yy265;
			goto yy81;
		}
	} else {
		if (yych <= '\\') {
			if (yych == '[') goto yy81;
			goto yy265;
		} else {
			if (yych <= ']') goto yy81;
			if (yych == 0x007F) goto yy81;
			goto yy265;
		}
	}
yy247:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '-') goto yy249;
		if (yych <= '9') goto yy247;
	} else {
		if (yych <= 'Z') goto yy247;
		if (yych <= '`') goto yy249;
		if (yych <= 'z') goto yy247;
	}
yy249:
#line 248 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1579 "mwlib/_uscan.cc"
yy250:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy81;
	goto yy269;
yy251:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy270;
	goto yy81;
yy252:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy271;
	goto yy81;
yy253:
	yych = *++YYCURSOR;
	if (yych == 'S') goto yy272;
	goto yy81;
yy254:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy273;
	goto yy81;
yy255:
	yych = *++YYCURSOR;
	if (yych == 'X') goto yy168;
	goto yy81;
yy256:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy274;
	goto yy81;
yy257:
	yych = *++YYCURSOR;
	if (yych == 'U') goto yy275;
	goto yy81;
yy258:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy276;
	goto yy81;
yy259:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '"') {
			if (yych == '!') goto yy259;
		} else {
			if (yych == '<') goto yy261;
			if (yych <= '=') goto yy259;
		}
	} else {
		if (yych <= '\\') {
			if (yych != '[') goto yy259;
		} else {
			if (yych <= ']') goto yy261;
			if (yych != 0x007F) goto yy259;
		}
	}
yy261:
#line 255 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1636 "mwlib/_uscan.cc"
yy262:
	yych = *++YYCURSOR;
yy263:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy262;
			if (yych <= '"') goto yy81;
			goto yy262;
		} else {
			if (yych <= ')') goto yy81;
			if (yych == ',') goto yy81;
			goto yy262;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy262;
			if (yych <= '>') goto yy81;
			goto yy262;
		} else {
			if (yych <= 'Z') {
				if (yych <= '@') goto yy277;
				goto yy262;
			} else {
				if (yych <= ']') goto yy81;
				if (yych <= '~') goto yy262;
				goto yy81;
			}
		}
	}
yy264:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy81;
	if (yych <= '9') goto yy278;
	goto yy81;
yy265:
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '"') {
			if (yych == '!') goto yy265;
		} else {
			if (yych == '<') goto yy267;
			if (yych <= '=') goto yy265;
		}
	} else {
		if (yych <= '\\') {
			if (yych != '[') goto yy265;
		} else {
			if (yych <= ']') goto yy267;
			if (yych != 0x007F) goto yy265;
		}
	}
yy267:
#line 254 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1691 "mwlib/_uscan.cc"
yy268:
	yych = *++YYCURSOR;
yy269:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy268;
			if (yych <= '"') goto yy81;
			goto yy268;
		} else {
			if (yych <= ')') goto yy81;
			if (yych == ',') goto yy81;
			goto yy268;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy268;
			if (yych <= '>') goto yy81;
			goto yy268;
		} else {
			if (yych <= 'Z') {
				if (yych <= '@') goto yy280;
				goto yy268;
			} else {
				if (yych <= ']') goto yy81;
				if (yych <= '~') goto yy268;
				goto yy81;
			}
		}
	}
yy270:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy281;
	goto yy81;
yy271:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy282;
	goto yy81;
yy272:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy283;
	goto yy81;
yy273:
	yych = *++YYCURSOR;
	if (yych == 'R') goto yy284;
	goto yy81;
yy274:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy285;
	goto yy81;
yy275:
	yych = *++YYCURSOR;
	if (yych == 'M') goto yy168;
	goto yy81;
yy276:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy286;
	goto yy81;
yy277:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy81;
			goto yy287;
		} else {
			if (yych <= '/') goto yy81;
			if (yych <= '9') goto yy287;
			goto yy81;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy287;
			if (yych <= '^') goto yy81;
			goto yy287;
		} else {
			if (yych <= '`') goto yy81;
			if (yych <= 'z') goto yy287;
			goto yy81;
		}
	}
yy278:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy290;
	if (yych <= '/') goto yy81;
	if (yych <= '9') goto yy278;
	goto yy81;
yy280:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy81;
			goto yy291;
		} else {
			if (yych <= '/') goto yy81;
			if (yych <= '9') goto yy291;
			goto yy81;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy291;
			if (yych <= '^') goto yy81;
			goto yy291;
		} else {
			if (yych <= '`') goto yy81;
			if (yych <= 'z') goto yy291;
			goto yy81;
		}
	}
yy281:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy294;
	goto yy81;
yy282:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy274;
	goto yy81;
yy283:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy295;
	goto yy81;
yy284:
	yych = *++YYCURSOR;
	if (yych == 'Y') goto yy168;
	goto yy81;
yy285:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy296;
	goto yy81;
yy286:
	yych = *++YYCURSOR;
	if (yych == 'H') goto yy297;
	goto yy81;
yy287:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy287;
		} else {
			if (yych <= '/') goto yy289;
			if (yych <= '9') goto yy287;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy287;
			if (yych >= '_') goto yy287;
		} else {
			if (yych <= '`') goto yy289;
			if (yych <= 'z') goto yy287;
		}
	}
yy289:
#line 247 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1844 "mwlib/_uscan.cc"
yy290:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy81;
	goto yy299;
yy291:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy291;
		} else {
			if (yych <= '/') goto yy293;
			if (yych <= '9') goto yy291;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy291;
			if (yych >= '_') goto yy291;
		} else {
			if (yych <= '`') goto yy293;
			if (yych <= 'z') goto yy291;
		}
	}
yy293:
#line 246 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1870 "mwlib/_uscan.cc"
yy294:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy300;
	goto yy81;
yy295:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy301;
	goto yy81;
yy296:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy302;
	goto yy81;
yy297:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy303;
	goto yy81;
yy298:
	yych = *++YYCURSOR;
yy299:
	if (yych <= '/') {
		if (yych == '-') goto yy304;
		goto yy81;
	} else {
		if (yych <= '9') goto yy298;
		if (yych <= '`') goto yy81;
		if (yych <= 'f') goto yy298;
		goto yy81;
	}
yy300:
	yych = *++YYCURSOR;
	if (yych == 'L') goto yy305;
	goto yy81;
yy301:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy306;
	goto yy81;
yy302:
	yych = *++YYCURSOR;
	if (yych == 'V') goto yy307;
	goto yy81;
yy303:
	yych = *++YYCURSOR;
	if (yych == 'A') goto yy308;
	goto yy81;
yy304:
	yych = *++YYCURSOR;
	if (yych == 'Q') goto yy309;
	goto yy81;
yy305:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy310;
	goto yy81;
yy306:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy311;
	goto yy81;
yy307:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy178;
	goto yy81;
yy308:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy312;
	goto yy81;
yy309:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy313;
	goto yy81;
yy310:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy314;
	goto yy81;
yy311:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy168;
	goto yy81;
yy312:
	yych = *++YYCURSOR;
	if (yych == 'I') goto yy315;
	goto yy81;
yy313:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy316;
	goto yy81;
yy314:
	yych = *++YYCURSOR;
	if (yych == 'K') goto yy168;
	goto yy81;
yy315:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy317;
	goto yy81;
yy316:
	yych = *++YYCURSOR;
	if (yych == 'U') goto yy318;
	goto yy81;
yy317:
	yych = *++YYCURSOR;
	if (yych == 'G') goto yy319;
	goto yy81;
yy318:
	yych = *++YYCURSOR;
	if (yych == 0x007F) goto yy320;
	goto yy81;
yy319:
	yych = *++YYCURSOR;
	if (yych == 'S') goto yy168;
	goto yy81;
yy320:
	++YYCURSOR;
#line 257 "mwlib/_uscan.re"
	{RET(t_uniq);}
#line 1983 "mwlib/_uscan.cc"
}
#line 314 "mwlib/_uscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_uscan();
}

DL_EXPORT(void) init_uscan()
{
	/*PyObject *m =*/ Py_InitModule("_uscan", module_functions);
}
